////////////////////////////////////////////////////////////////////////////////
///                        timezone_converter.c                              ///
///     Routines for handling time zones and daylight saving time            ///
///     of clock / calendar                                                  ///
///                                                                          ///
/// Copyright 2017 Jaakko Kairus                                             ///
/// jaakko@kair.us                                                           ///
///                                                                          ///
/// You may freely use and modify this software for personal use.            ///
/// Commercial use of this software or parts of it is prohibited             ///
/// without written permission from author.                                  ///
/// DISCLAIMER: This software comes with ABSOLUTELY NO WARRANTY              ///
///                                                                          ///
/// For more information about this project see project web page at          ///
/// http://kair.us/projects/clock/v4/index.html                              ///
///                                                                          ///
/// Developed with CCS compiler version 5.076                                ///
///                                                                          ///
////////////////////////////////////////////////////////////////////////////////

#include <time.h>
#include <time.c>

void utc_to_local(struct_tm* utc, struct_tm* local, signed int8 timezone) {
	time_t unix_seconds;
	struct_tm* temp_time;
	unix_seconds = mktime(utc);
	unix_seconds += timezone*3600;
	temp_time = localtime(&unix_seconds);		// must use temporary pointer and then copy the struct since localtime 
	*local=*temp_time;							// returns pointer to a struct than can be overwritten
	//*local = localtime(&unix_seconds);
}

int8 eu_summertime(struct_tm* utc) {
	int8 day_begin, day_end;
	day_begin = (31 - ((((5 * ((utc->tm_year)+1900)) / 4) + 4) % 7));
	day_end   = (31 - ((((5 * ((utc->tm_year)+1900)) / 4) + 1) % 7));
	switch (utc->tm_mon) {
		case JANUARY:
		case FEBRUARY:
			return 0;
		case MARCH:
			if (utc->tm_mday >= day_begin && utc->tm_hour>=1)
				return 1;
			else
				return 0;
		case APRIL:
		case MAY:
		case JUNE:
		case JULY:
		case AUGUST:
		case SEPTEMBER:
			return 1;
		case OCTOBER:
			if (utc->tm_mday >= day_end && utc->tm_hour>=1)
				return 0;
			else
				return 1;
		case NOVEMBER:
		case DECEMBER:
			return 0;
	}	
}	
	


